/******************************************************************************
 *	subwin.c:	TuEBhȄ֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "subwin.h"		/* ̃vOŗL̃wb_t@C	*/

static Rect wsSize = { 0, 0, SUBWIN_H, SUBWIN_V }; /* TuEBhETCY */

/******************************************************************************
 *	createSubwin():	TuEBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createSubwin(ComVal *pcv)
{
	Rect rc;

	pcv->subRgnHdl = GMNewRgn();	/* [Wnhmۂ	*/
	if (pcv->subRgnHdl == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	/* TuEBhE̊Ogi[Wjݒ肷 */
	rc = wsSize;
	rc.d.right--;
	rc.d.bottom--;
	GMRectRgn(pcv->subRgnHdl, &rc);
	rc.d.left += 4;
	rc.d.top += 4;
	rc.d.right++;
	rc.d.bottom++;
	GMOrRectRgn(pcv->subRgnHdl, pcv->subRgnHdl, &rc);
	GMSlideRgn(pcv->subRgnHdl, TSGetWindowPos());

	return openSubwin(pcv);		/* TuEBhEI[vłH */
}

/******************************************************************************
 *	openSubwin():	TuEBhẼI[v
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  I[v
 *				= FALSE: I[vs
 */
BOOLEAN openSubwin(ComVal *pcv)
{
	pcv->subwinPtr = WSOpen(	/* TuEBhEI[v	*/
		NULL,			/* TuEBhE|C^mۂ */
		pcv->subRgnHdl,		/* [Wnh		*/
		32);			/* vCIeBliʏ32ȏj*/
	if (pcv->subwinPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	/* TuEBhEJgOtɂ */
	GMSetGraph(&pcv->subwinPtr->win.graph);
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);
	/* ^XNhc̏ʃ[hɃTuEBhE̒ʂԍ(OȊO) */
	pcv->subwinPtr->win.taskID = LONGWORD(1, TSGetID());
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	closeSubwin():	TuEBhẼN[Y
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void closeSubwin(ComVal *pcv)
{
	WSDispose(pcv->subwinPtr);	/* TuEBhEN[Y	*/
}

/******************************************************************************
 *	msLDownSubwin(): TuEBhẼ}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	int		TuEBhẼp[gR[h
 *	:
 *	TuEBhEŃ}EX̍{^ꂽꍇ̏sBT|[g
 *	鏈́ATuEBhËړAN[Y{^̋\ŁA}EX
 *	̃{^ꂽA܂͗ꂽꏊ̃p[gR[h擾܂B
 */
int msLDownSubwin(ComVal *pcv)
{
	LPoint lpt;

	static Rect rcClose = {		/* TuEBhẼN[Y{^ */
		CLOSE_X, CLOSE_Y, CLOSE_X + WS_CLOSE_W, CLOSE_Y + WS_CLOSE_W
	};
	static Rect wsInside = {	/* TuEBhE̓		*/
		WS_INSIDE_X, WS_INSIDE_Y, SUBWIN_H - 2, SUBWIN_V - 2
	};

	/* TuEBhEJgOtɂ */
	GMSetGraph(&pcv->subwinPtr->win.graph);

	/* Cxg̃|C^W[JWnɕϊ */
	lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
	if (GMPtInRect(&rcClose, lpt)) { /* N[Y{^ꂽH */
		if (checkPctBtn(pcv, &rcClose, lpt)) {
			WSDelist(pcv->subwinPtr); /* TuEBhE */
			pcv->subActiveFlag = FALSE;
			return WS_INCLOSE;
		}
	} else if (GMPtInRect(&wsInside, lpt)) { /* TuEBhE̓H */
		return WS_ININSIDE;

	/* TuEBhẼhbO[WiłȂj*/
	} else {
		dragSubwin(pcv, lpt);	/* TuEBhEhbO	*/
		return WS_INDRAG;
	}

	return 0;
}

/******************************************************************************
 *	dragSubwin():	TuEBhẼhbOiړj
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		LPoint lpt	|C^W([JWnj
 */
void dragSubwin(ComVal *pcv, LPoint lpt)
{
	Point pt, pt2, npt, dpt;
	Rect rc;

	rc = wsSize;
	GMInvertRect(			/* o[oh`悷	*/
		&rc,			/* \郌N^O		*/
		WS_RUBBERBAND);		/* TuEBhẼo[oh	*/

	pt.x_y = lpt;
	/* TuEBhE̍W}EX݈̌ʒu܂ł̋vZ */
	pt2.p.x = pcv->event.ev.where.p.x - (*pcv->subRgnHdl)->bounds.d.left;
	pt2.p.y = pcv->event.ev.where.p.y - (*pcv->subRgnHdl)->bounds.d.top;
	/* }EX̍{^ꂽ܂܂ȂAo[ohړ */
	do {
		npt.x_y = EMMSLoc();	/* }EX݈̌ʒu擾	*/
		if (npt.x_y != pt.x_y) { /* }EXړH	*/
			/* o[oh */
			GMInvertRect(&rc, WS_RUBBERBAND);
			/* ړ̃N^Oݒ肷 */
			dpt.p.x = npt.p.x - pt.p.x;
			dpt.p.y = npt.p.y - pt.p.y;
			GMSlideRect(&rc, dpt.x_y);
			/* o[oh`悷 */
			GMInvertRect(&rc, WS_RUBBERBAND);
		}
		pt = npt;
	} while (EMLStill());		/* {^ꂽI */
	GMInvertRect(&rc, WS_RUBBERBAND); /* o[oh	*/

	/* {^ꂽʒuhbOJnʒuƓH */
	if (pt.x_y == lpt)
		return;			/* ꍇ͂̂܂		*/

	/* ړ̃TuEBhE̊Ogi[Wjݒ肷 */
	pt.p.x -= pt2.p.x;
	pt.p.y -= pt2.p.y;
	GMSlideRgn(pcv->subRgnHdl, pt.x_y);

	/* TuEBhËړ́ATuEBhExN[Y
	   V[WōēxI[v */
	closeSubwin(pcv);		/* TuEBhEN[Y	*/
	if (!openSubwin(pcv)) {		/* TuEBhEI[v	*/
		/* TuEBhEI[vłȂ̂ŁAhbO͎s */
		pcv->subActiveFlag = FALSE;
		pcv->errorCode = 5;
		pcv->endFlag = TRUE;	/* ItOZbg	*/
	}
}

/******************************************************************************
 *	drawSubwin():	TuEBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawSubwin(ComVal *pcv)
{
	int lastAP, lastPM;
	Rect rc;

	/* TuEBhEJgOtɂ */
	GMSetGraph(&pcv->subwinPtr->win.graph);

	rc = wsSize;
	/* TuEBhE`悷ꍇ́A܂ŚiSy[WjNA */
	lastAP = GMAPage(G_ALLPAGE);	/* ANZXy[WSy[Wɂ */
	/* y[hobNOEhJ[ɂ */
	lastPM = GMPenMode(G_BACK << 8 | G_PSET);
	GMFillRect(&rc);		/* TuEBhENA	*/
	GMPenMode(lastPM);		/* y[hɖ߂		*/
	GMAPage(lastAP);		/* ANZXy[Wɖ߂	*/

	GMFrameRect(&rc);		/* TuEBhE̊Og`悷 */
	rc.d.right--;
	rc.d.bottom--;
	GMFrameRect(&rc);

	drawSubTitleBar(pcv);		/* ^Cgo[`悷	*/
}

/******************************************************************************
 *	drawSubTitleBar():	TuEBhẼ^Cgo[̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawSubTitleBar(ComVal *pcv)
{
	int i;

	/* TuEBhẼ^Cgo[̕` */
	static struct {
		int color;
		Rect rc;
	} wsTitle[7] = {
		{ G_DGRAY, {		1,  1, SUBWIN_H - 2, 17 }},
		{ G_WHITE, {		1,  1,		  3, 16 }},
		{ G_WHITE, {		3,  1, SUBWIN_H - 2,  3 }},
		{ G_DGRAY, {		2, 15, SUBWIN_H - 2, 18 }},
		{ G_BLACK, { SUBWIN_H - 3,  2, SUBWIN_H - 1, 17 }},
		{ G_BLACK, {		1, 16, SUBWIN_H - 3, 17 }},
		{ G_BLACK, {		3, 15, SUBWIN_H - 3, 16 }}
	};
	/* TuEBhEpN[Y{^̃N^OC[W */
	static unsigned short wsClose[4 + 10 * 2] = {
		0, 0, WS_CLOSE_W, WS_CLOSE_W, /* oEhN^O	*/
		/* rbgC[WiPy[Wځj*/
		0x0040, 0x7fc0, 0x7fc0, 0x7ec0, 0x7dc0, 0x7fc0, 0x77c0, 0x6fc0,
		0x7fc0, 0xffc0,
		/* rbgC[WiQy[Wځj*/
		     0, 0x0040, 0x2140, 0x1240, 0x0c40, 0x0c40, 0x1240, 0x2140,
		0x0040, 0x7fc0
	};

	/* TuEBhẼ^Cgo[`悷 */
	for (i = 0; i < 7; i++) {
		GMForeColor(wsTitle[i].color);
		GMFillRect(&wsTitle[i].rc);
	}
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɖ߂ */

	/* N[Y{^`悷 */
	GMPutRImg((RectImg *) wsClose, LONGWORD(CLOSE_X, CLOSE_Y));
}

/******************************************************************************
 *	checkPctBtn():	sN`[{^̃`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		Rect *prc	sN`[{^̃N^Oւ̃|C^
 *		LPoint lpt	|C^W([JWnj
 *	߂l:	BOOLEAN overFlag = TRUE:  sN`[{^̏ŗꂽ
 *				 = FALSE: sN`[{^̊Oŗꂽ
 */
BOOLEAN checkPctBtn(ComVal *pcv, Rect *prc, LPoint lpt)
{
	BOOLEAN now, overFlag = TRUE;

	revFillRect(prc);		/* sN`[{^𔽓]	*/
	/* }EX̍{^܂Ń[v */
	do {
		now = GMPtInRect(prc, EMMSLoc());
		if (now != overFlag) {
			/* }EẌʒusN`[{^ォωA
			   sN`[{^𔽓] */
			revFillRect(prc);
			overFlag = now;
		}
	} while (EMLStill());		/* {^ꂽI	*/

	return overFlag;
}

/******************************************************************************
 *	revFillRect():	N^ȎSʔ]
 ******************************************************************************
 *	:	Rect *prc	]郌N^Oւ̃|C^
 */
void revFillRect(Rect *prc)
{
	int lastPM;

	lastPM = GMPenMode(G_XOR);	/* y[hXORɐݒ肷	*/
	GMFillRect(prc);
	GMPenMode(lastPM);		/* y[hɖ߂		*/
}
